#include <stdio.h>
#include <stdlib.h>

/* some f2c string conversions */
char *_stringF2C(char *title,int len_title){
char *headtitle=NULL;
int i=len_title-1;
/* get c string length of fortran string */
while ((i>=0)&&(title[i]==' ')) i--;
/* if it has characters copy them else return a NULL string */
/* return a headtitle as NULL pointer is not accepted by Dialog's 3-04-06*/
/* i is length-1 so to add 1 char , put i+2 */
headtitle=malloc((i+2)*sizeof(char));
headtitle[i+1]='\0';
if (i>=0){
 while (i>=0){headtitle[i]=title[i];i--;}
}
return headtitle;
}
void _stringC2F(char *F,char *C,int lenF){
int i=0;
if (C!=NULL) { while (i<lenF && C[i]!='\0') {F[i]=C[i++];} }
while (i<lenF) F[i++]=' ';
}

#include "app.h"

/* try to interface to G77 */
App *gapp;

/* callback give the pointer to menu/controll structure */ 
int CallBackId=0;
int callback(int i){
CallBackId=i;
return 0;
}
/* general converting callback's , -1 none 0 scanner else func() */
int *get_hook(int *hook){
if (*hook==0){       /* use callback as a scanner */
 return (int*)callback;
}else if(*hook==-1){ /* no callback given */
 return NULL;
}else{                      /* a callback funcion is given */
 return hook;
}
}


void graph_start__(){
gapp=app_new_app(0,0);
}

void graph_stop__(){
app_del_app(gapp);
}

/* Use this if CallBack functions are given ! */
void main_loop__(){
app_main_loop(gapp);
}

/* Use this if you run the events as a scanner !
   give a event back to main programm
   as result 0 window is closed
   as result 1 unknow event
   else result is a pointer to menu/control structure */
int next_event__(){;
int res;
if (app_wait_event(gapp)){
  if (CallBackId){ 
    res = CallBackId;
    CallBackId = 0;
  } else {
    res = 1;
  }
} else {
  res = 0;
}
return res;
}

/* declarations and operations on the window system */

int new_window__(rect,title,mode,len_title)
char *title;int *mode,*rect,len_title;{
char *headtitle=_stringF2C(title,len_title);
//printf("Dim %x ? %d %d %d %d\n",*mode,rect[0],rect[1],rect[2],rect[3]);
Rect r={rect[0],rect[1],rect[2],rect[3]};
int win = (int)app_new_window(gapp,r,headtitle,*mode);
free(headtitle);
return win;
}

void show_window__(win)
int *win;{
//printf("window pointer = %d\n",*win);
app_show_window((Window*)*win);
}

/* dialog's */

enum { ASKOKE,ASKOKECANCEL,ASKYESNO,ASKYESNOCANCEL,ASKSTRING,ASKFILEOPEN,ASKFILESAVE };

short int askokeyesno(type,title,text,lentitle,lentext)
char *title,*text; int lentitle,lentext,type;{
char *ht=_stringF2C(title,lentitle);
char *bt=_stringF2C(text,lentext);
int  res;
switch (type) {
case ASKOKE:
 app_ask_ok(gapp,ht,bt);
 res = 0;
 break;
case ASKOKECANCEL:
 res=app_ask_ok_cancel(gapp,ht,bt);
 break;
case ASKYESNO:
 res=app_ask_yes_no(gapp,ht,bt);
 break;
case ASKYESNOCANCEL:
 res=app_ask_yes_no_cancel(gapp,ht,bt);
 break;
}
free(ht);
free(bt);
return (short int)res;
}

void ask_oke__(title,text,lentitle,lentext)
char *title,*text; int lentitle,lentext;{
short int temp=askokeyesno(ASKOKE,title,text,lentitle,lentext);
}

short int ask_oke_cancel__(title,text,lentitle,lentext)
char *title,*text; int lentitle,lentext;{
return askokeyesno(ASKOKECANCEL,title,text,lentitle,lentext);
}

short int ask_yes_no__(title,text,lentitle,lentext)
char *title,*text; int lentitle,lentext;{
return askokeyesno(ASKYESNO,title,text,lentitle,lentext);
}

short int ask_yes_no_cancel__(title,text,lentitle,lentext)
char *title,*text; int lentitle,lentext;{
return askokeyesno(ASKYESNOCANCEL,title,text,lentitle,lentext);
}

short int askfunc(type,answ,lenansw,title,text,defansw,lentitle,lentext,lendefansw)
int type;char *answ,*title,*text,*defansw; int lenansw,lentitle,lentext,lendefansw;{
char *ht=_stringF2C(title,lentitle);
char *bt=_stringF2C(text,lentext);
char *da=_stringF2C(defansw,lendefansw);
char *ans;
int  i=0;

switch (type) {
case ASKSTRING:
 ans=app_ask_string(gapp,ht,bt,da);
 break;
case ASKFILEOPEN:
 ans=app_ask_file_open(gapp,ht,bt,da);
 break;
case ASKFILESAVE:
 ans=app_ask_file_save(gapp,ht,bt,da);
 break;
}

/* seems that filepath hase only '/' as seperator
   windows needs '\' as seperator (you have to know the compiler directive)
   I think this should be done by GraphApp and not by the wrapper ! */
free(ht);
free(bt);
free(da);
if (ans==NULL){
 return -1;
} else {
 #ifdef __MINGW32__
 while (ans[i]!=0){
  if (ans[i]=='/') ans[i]='\\';
  i++;
 }
 #endif
 _stringC2F(answ,ans,lenansw);
 free(ans);
 return 0;
}
}

short int ask_string__(title,text,defansw,answ,lentitle,lentext,lendefansw,lenansw)
char *answ,*title,*text,*defansw; int lenansw,lentitle,lentext,lendefansw;{
askfunc(ASKSTRING,answ,lenansw,title,text,defansw,lentitle,lentext,lendefansw);
}

short int ask_file_open__(title,text,defansw,answ,lentitle,lentext,lendefansw,lenansw)
char *answ,*title,*text,*defansw; int lenansw,lentitle,lentext,lendefansw;{
askfunc(ASKFILEOPEN,answ,lenansw,title,text,defansw,lentitle,lentext,lendefansw);
}

short int ask_file_save__(title,text,defansw,answ,lentitle,lentext,lendefansw,lenansw)
char *answ,*title,*text,*defansw; int lenansw,lentitle,lentext,lendefansw;{
askfunc(ASKFILESAVE,answ,lenansw,title,text,defansw,lentitle,lentext,lendefansw);
}

/* menubar , menu's , menuitem's */

int new_menu_bar__(win)
int *win;{
return (int)app_new_menu_bar((Window*)*win);
}

int new_menu__(bar,text,lentext)
int *bar,lentext;char *text;{
int res;
char *txt=_stringF2C(text,lentext);
res = (int)app_new_menu((MenuBar*)*bar,txt);
free(txt);
return res;
}

int new_menu_item__(bar,text,key,callbackref,lentext)
int *bar,*callbackref,lentext;char *text,*key;{
int res;
char *txt=_stringF2C(text,lentext);
//printf("item = %d %s %d %c %d\n",*bar,txt,lentext,key[0],callbackref);
res = (int)app_new_menu_item((Menu*)*bar,txt,key[0],(MenuAction)get_hook(callbackref));
free(txt);
return res;
}

/* list-boxes */
int new_list_box__(win,rect,list,hook,lentxt)
int *win,*rect,*hook;char *list;{
char **a;
Rect r={rect[0],rect[1],rect[2],rect[3]};
//printf("listbox %d %d %d\n",*win,hook,lentxt);
if(lentxt){
 a=(char**)malloc((2)*sizeof(char*));
 a[0]=_stringF2C(list, lentxt);
 a[1]='\0';
 printf("listbox text %s\n",a[0]);
} else {
 a=NULL;
}
return (int)app_new_list_box((Window*)*win,r,a,(ControlFunc)get_hook(hook));
}

/* dit zou berijkbaar moeten zijn uit 'listbox.c' */

typedef struct ListBox  ListBox;
struct ListBox {
	int num_lines;
	char **list;
	int left;
	int top;
	int old_value;
	int vert_max, vert_pagesize;
	int horz_max, horz_pagesize;
	Control *parent;
	Control *vert;
	Control *horz;
	Control *box;
};

enum {
	SCROLL_SIZE = 16,
	BOX_BORDER  = SCROLL_SIZE
};
//extern void app_listbox_resize(Control*);
static void app_listbox_resize(Control *c)
{
	int i, h, max, pagesize, w;
	char ** list;
	Font *f;
	Rect r;
	ListBox *lb;

	lb = c->extra;

	/* fix up scroll bars */
	r = app_get_control_area(c);
	f = lb->parent->font;
	h = app_font_height(f) + 1;

	/* count items in list */
	list = lb->list;
	if (list != NULL)
		for (max=0; list[max] != NULL; max++)
			continue;
	else
		max = 0;

	/* determine vertical scrollbar placement */
	pagesize = (r.height -BOX_BORDER -8) / h;
	max = max - pagesize;
	if (max < 0)
		max = 0;
	if (lb->top > max)
		lb->top = max;
	lb->vert_max = max;
	lb->vert_pagesize = pagesize;

	app_set_control_area(lb->vert, rect(r.width-SCROLL_SIZE, 0,
				SCROLL_SIZE, r.height-BOX_BORDER));
	app_change_scroll_bar(lb->vert, lb->top, max, pagesize);

	/* find maximum item width */
	if (list != NULL) {
		for (i=max=0; list[i] != NULL; i++) {
			w = app_font_width(f, list[i], (int) strlen(list[i]));
			if (max < w)
				max = w;
		}
	}
	else
		max = 0;

	/* determine horizontal scrollbar placement */
	pagesize = r.width -BOX_BORDER -8;
	max = max - pagesize;
	if (max < 0)
		max = 0;
	if (lb->left > max)
		lb->left = max;
	lb->horz_max = max;
	lb->horz_pagesize = pagesize;

	app_set_control_area(lb->horz, rect(0, r.height-SCROLL_SIZE,
				r.width-BOX_BORDER, SCROLL_SIZE));
	app_change_scroll_bar(lb->horz, lb->left, max, pagesize);

	/* resize the list box itself */
	app_set_control_area(lb->box, rect(0, 0,
				r.width-BOX_BORDER, r.height-BOX_BORDER));
}
/* ende copy uit listbox.c */

void add_list_item__(c,txt,lentxt)
int *c,lentxt;char *txt;{
ListBox *lb;
Control *control;
char **new_list;
int lenlist;
control=(Control*)*c;
lb = control->extra;
if (lb->num_lines) { /* exist */
 lb->num_lines+=1;
 lb->list=(char**)realloc(lb->list,(lb->num_lines+1)*sizeof(char*));
} else {             /* new   */
 lb->num_lines=1;
 lb->list=(char**)malloc((lb->num_lines+1)*sizeof(char*));
}
lb->list[lb->num_lines]=0;
lb->list[lb->num_lines-1]=_stringF2C(txt, lentxt);
if (lb->parent->value >= lb->num_lines)lb->parent->value = lb->num_lines-1;
app_listbox_resize(control);
app_redraw_control(lb->box);
}

int get_list_box_item__(c)
int *c;{
return app_get_list_box_item((Control*)*c);
}

/* text-boxes */
int new_text_box__(win,rect,list,lentxt)
int *win,*rect;char *list;{
int res;
char *txt;
Rect r={rect[0],rect[1],rect[2],rect[3]};
//printf("listbox %d %d\n",*win,lentxt);
txt=_stringF2C(list, lentxt);
res = (int)app_new_text_box((Window*)*win,r,txt);
free(txt);
return res;
}

void get_control_text__(b,lentxt,c)
int *c,lentxt;char* b;{
/* Fortran G77
   character *k txt,get_control_text
   txt=get_control_text(Control)
   The char_function seems be handled as a procedure .
   The first parameter is the position of the answer .
   Second the length of the answer .
   Third the first parameter given in the caller .
*/
_stringC2F(b,app_get_control_text((Control*)*c),lentxt);
}

/* buttons */
int new_button__(w,rect,txt,hook,lentxt)
int *w,*rect,*hook,lentxt;char *txt;{
Rect r={rect[0],rect[1],rect[2],rect[3]};
return (int)app_new_button((Window*)*w,r,_stringF2C(txt,lentxt),(ControlFunc)get_hook(hook));
}

